//+------------------------------------------------------------------+
//|                                                    Slingshot.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property copyright "Copyright  2015, mlaaden"
#property link      "http://fxcodebase.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
};
enum maTypes
{
   ma_sma,     // sma (simple moving average)
   ma_ema,     // ema (exponential moving average)
   ma_smma,    // smma (smoothed moving average)
   ma_lwma     // lwma (liner weighted moving average)
};

extern int      Length1         = 14;
extern enPrices Price1          = pr_close;
extern int      Length2         = 14;
extern enPrices Price2          = pr_low;
extern int      preSmooth       = 5;
extern maTypes  preSmoothMethod = ma_sma;

                        

double B1[], B2[];

int init()
{
 IndicatorShortName("Slingshot oscillator");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(0,B1);
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(1,B2);
preSmooth = MathMax(preSmooth,1);
 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double Pr10, Pr11, Pr20, Pr21;
 pos=limit;
 while(pos>=0)
 {
  Pr10=iMA(NULL, 0, preSmooth, 0, (int)preSmoothMethod, (int)Price1, pos);
  Pr11=iMA(NULL, 0, preSmooth, 0, (int)preSmoothMethod, (int)Price1, pos+Length1);
  Pr20=iMA(NULL, 0, preSmooth, 0, (int)preSmoothMethod, (int)Price2, pos);
  Pr21=iMA(NULL, 0, preSmooth, 0, (int)preSmoothMethod, (int)Price2, pos+Length2);
  
  B1[pos]=Pr10-Pr11;
  B2[pos]=Pr20-Pr21;

  pos--;
 } 
 return(0);
}

